# __GPSSBlock.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Integer import *
from ATOM3String import *
from graph_GPSSBlock import *
class GPSSBlock(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_GPSSBlock
      self.parent = parent
      self.Label=ATOM3String('L')
      self.keyword_= self.Label
      self.Type=ATOM3Enum(['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0, 0)
      self.A=ATOM3String('')
      self.B=ATOM3String('')
      self.C=ATOM3String('')
      self.D=ATOM3String('')
      self.E=ATOM3String('')
      self.F=ATOM3String('')
      self.X=ATOM3String('')
      self.Comments=ATOM3String('')
      self.generatedAttributes = {'Type': ('ATOM3Integer', ),
                                  'A': ('ATOM3String', ),
                                  'B': ('ATOM3String', ),
                                  'C': ('ATOM3String', ),
                                  'D': ('ATOM3String', ),
                                  'E': ('ATOM3String', ),
                                  'F': ('ATOM3String', ),
                                  'Label': ('ATOM3String', ),
                                  'X': ('ATOM3String', ),
                                  'Comments': ('ATOM3String', )      }
      self.realOrder = ['Type','A','B','C','D','E','F','Label','X','Comments']
   def clone(self):
      cloneObject = GPSSBlock( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      cloneObject.keyword_ = cloneObject.Label
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      self.keyword_ = self.Label
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if actionID == self.EDIT:
         res = self.storeLabel(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.EDIT or actionID == self.CREATE:
         res = self.changeIcon(params)
         if res: return res
      if actionID == self.DISCONNECT:
         res = self.disconnectTransfer(params)
         if res: return res
      if actionID == self.EDIT:
         res = self.changedLabel(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def changeIcon(self, params):
      if self.parent.editGGLabel: return
      tval =self.Type.getValue()
      tname=tval[0][tval[1]]
      cx, cy = self.graphObject_.x, self.graphObject_.y
      oldObject = self.graphObject_
      if tname == 'Generate':
         from graph_Generate import *
         self.graphObject_=graph_Generate(cx, cy, self)
      elif tname == 'Advance':
         from graph_Advance import *
         self.graphObject_=graph_Advance(cx, cy, self)
      elif tname == 'Transfer':
         from graph_Transfer import *
         self.graphObject_=graph_Transfer(cx, cy, self)
      elif tname == 'Terminate':
         from graph_Terminate import *
         self.graphObject_=graph_Terminate(cx, cy, self)
      elif tname == 'Assign':
         from graph_Assign import *
         self.graphObject_=graph_Assign(cx, cy, self)
      elif tname == 'Depart':
         from graph_Depart import *
         self.graphObject_=graph_Depart(cx, cy, self)
      elif tname == 'Enter':
         from graph_Enter import *
         self.graphObject_=graph_Enter(cx, cy, self)
      elif tname == 'Gate':
         from graph_Gate import *
         self.graphObject_=graph_Gate(cx, cy, self)
      elif tname == 'Leave':
         from graph_Leave import *
         self.graphObject_=graph_Leave(cx, cy, self)
      elif tname == 'Link':
         from graph_Link import *
         self.graphObject_=graph_Link(cx, cy, self)
      elif tname == 'Priority':
         from graph_Priority import *
         self.graphObject_=graph_Priority(cx, cy, self)
      elif tname == 'Queue':
         from graph_Queue import *
         self.graphObject_=graph_Queue(cx, cy, self)
      elif tname == 'Release':
         from graph_Release import *
         self.graphObject_=graph_Release(cx, cy, self)
      elif tname == 'SaveValue':
         from graph_SaveValue import *
         self.graphObject_=graph_SaveValue(cx, cy, self)
      elif tname == 'Seize':
         from graph_Seize import *
         self.graphObject_=graph_Seize(cx, cy, self)
      elif tname == 'Tabulate':
         from graph_Tabulate import *
         self.graphObject_=graph_Tabulate(cx, cy, self)
      elif tname == 'Unlink':
         from graph_Unlink import *
         self.graphObject_=graph_Unlink(cx, cy, self)
      elif tname == 'Mark':
         from graph_Mark import *
         self.graphObject_=graph_Mark(cx, cy, self)
      elif tname == 'Test':
         from graph_Test import *
         self.graphObject_=graph_Test(cx, cy, self)
      elif tname == 'Logic':
         from graph_Logic import *
         self.graphObject_=graph_Logic(cx, cy, self)
      self.graphObject_.connections = []+oldObject.connections
      oldObject.erase(self.parent,0)
      self.graphObject_.DrawObject(self.parent.UMLmodel, self.parent.editGGLabel)
      self.parent.UMLmodel.addtag_withtag("GPSSBlock", self.graphObject_.tag)
      self.graphObject_.semanticObject = oldObject.semanticObject
      
      
      
      
      
      
      
      
      
      
      
      

   def disconnectTransfer(self, params):
      if self.Type.toString() == "Transfer" and params[1] == "SOURCE":
         if params[0].Label.toString() == self.B.toString(): self.B.setValue("")
         elif params[0].Label.toString() == self.C.toString(): self.C.setValue("")
      elif self.Type.toString() == "Gate" and params[1] == "SOURCE":
         if params[0].Label.toString() == self.B.toString(): self.B.setValue("")
      elif self.Type.toString() == "Test" and params[1] == "SOURCE":
         if params[0].Label.toString() == self.C.toString(): self.C.setValue("")
      return None
      
      
      
      

   def storeLabel(self, params):
      self.parent.oldLabel = self.Label.toString()
      return None
      
      
      
      
      
      

   def changedLabel(self, params):
      for conn in self.in_connections_:
        if conn.in_connections_[0].Type.toString() == "Transfer":
           if conn.in_connections_[0].B.toString() == self.parent.oldLabel: conn.in_connections_[0].B.setValue(self.Label.toString())
           if conn.in_connections_[0].C.toString() == self.parent.oldLabel: conn.in_connections_[0].C.setValue(self.Label.toString())
        elif conn.in_connections_[0].Type.toString() == "Gate":
           if conn.in_connections_[0].B.toString() == self.parent.oldLabel: conn.in_connections_[0].B.setValue(self.Label.toString())
        elif conn.in_connections_[0].Type.toString() == "Test":
           if conn.in_connections_[0].C.toString() == self.parent.oldLabel: conn.in_connections_[0].C.setValue(self.Label.toString())
      
      
      
      
      
      
      
      



