# __connected_to.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from graph_connected_to import *
class connected_to(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_connected_to
      self.parent = parent
      self.generatedAttributes = {      }
      self.realOrder = []
   def clone(self):
      cloneObject = connected_to( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.CONNECT:
         res = self.setConnections(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def setConnections(self, params):
      if params[0] == "SOURCE" and len(self.in_connections_) > 0:
         node = self.in_connections_[0] 
         if node.Type.toString() == "Transfer":
            if node.B.toString() == "": 
               node.B.setValue(self.parent.sem_objTo.Label.toString())
            elif len(node.out_connections_)>1:
               node.C.setValue(self.parent.sem_objTo.Label.toString())
         elif node.Type.toString() == "Gate":
            if node.B.toString() == "":
               node.B.setValue(self.parent.sem_objTo.Label.toString())
         elif node.Type.toString() == "Test":
            if node.C.toString() == "":
               node.C.setValue(self.parent.sem_objTo.Label.toString())
      
      
      
      



