from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_Link(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 128, 114
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_rectangle(self.translate([1.0, 31.0, 87.0, 82.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= 'lightblue')
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        h = drawing.create_oval(self.translate([43.0, 31.0, 43.0, 31.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([41.0, 83.0, 41.0, 83.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_line(self.translate([87.0, 32.0, 102.0, 2.0, 117.0, 32.0]), tags = self.tag, stipple= '', width= '1.0', splinesteps= '12', arrowshape= '8 10 3', arrow= 'none', capstyle= 'butt', smooth= 1, joinstyle= 'round', fill= 'black')
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)
        h = drawing.create_line(self.translate([87.0, 82.0, 102.0, 112.0, 117.0, 82.0]), tags = self.tag, stipple= '', width= '1.0', splinesteps= '12', arrowshape= '8 10 3', arrow= 'none', capstyle= 'butt', smooth= 1, joinstyle= 'round', fill= 'black')
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        h = drawing.create_line(self.translate([117.0, 32.0, 117.0, 82.0]), tags = self.tag, stipple= '', width= '1.0', splinesteps= '12', arrowshape= '8 10 3', arrow= 'none', capstyle= 'butt', smooth= 0, joinstyle= 'round', fill= 'black')
        self.gf5 = GraphicalForm(drawing, h, "gf5")
        self.graphForms.append(self.gf5)
        h = drawing.create_oval(self.translate([3.0, 56.0, 3.0, 56.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([119.0, 59.0, 119.0, 59.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        if self.semanticObject: drawText = self.semanticObject.A.toString(25,5)
        else: drawText = "<A>"
        h = drawing.create_text(self.translate([100.0, 33.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'blue', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["A"] = h
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)
        if self.semanticObject: drawText = self.semanticObject.B.toString(25,5)
        else: drawText = "<B>"
        h = drawing.create_text(self.translate([102.0, 80.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'blue', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["B"] = h
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_Link
